"use strict";
Vue.component('ibiz-app-menu', {
    template: "\n        <div class=\"ibiz-app-menu\">\n            <el-menu class=\"ibiz-menu\" :default-openeds=\"ctrl.defaultOpeneds\" :mode=\"mode\" :menu-trigger=\"trigger\" @select=\"onSelect\" :default-active=\"ctrl.selectItem.id\" :collapse=\"isCollapse\">\n                <template v-for=\"(item0, index0) in ctrl.items\">\n\n                    <!---  \u4E00\u7EA7\u83DC\u5355\u6709\u5B50\u9879 begin  --->\n                    <template v-if=\"item0.items && item0.items.length > 0\">\n                        <el-submenu v-show=\"!item0.hidden\" :index=\"item0.id\" :popper-class=\"['ibiz-popper-menu', $root.themeClass]\">\n                            <template slot=\"title\">\n                                <img v-if=\"item0.icon != ''\" :src=\"item0.icon\"/>\n                                <i v-else class=\"ibiz-menu-icon\" :class=\"[item0.iconcls == '' ? 'fa fa-cogs' : item0.iconcls ]\" aria-hidden=\"true\"></i>\n                                <span slot=\"title\">{{ item0.text }}</span>\n                                <Icon class=\"active-icon\" type=\"md-arrow-dropleft\" />\n                            </template>\n                            <template v-for=\"(item1, index1) in item0.items\">\n\n                                <!---  \u4E8C\u7EA7\u83DC\u5355\u6709\u5B50\u9879 begin  --->\n                                <template v-if=\"item1.items && item1.items.length > 0\">\n                                    <el-submenu v-show=\"!item1.hidden\" :index=\"item1.id\">\n                                        <template slot=\"title\">\n                                            <img v-if=\"item1.icon != ''\" :src=\"item1.icon\"/>\n                                            <i v-else class=\"ibiz-menu-icon\" v-if=\"item1.iconcls != ''\" :class=\"item1.iconcls\" aria-hidden=\"true\"></i>\n                                            <span slot=\"title\">{{ item1.text }}</span>\n                                        </template>\n\n                                        <!---  \u4E09\u7EA7\u83DC\u5355 begin  --->\n                                        <template v-for=\"(item2, index2) in item1.items\">\n                                            <el-menu-item v-show=\"!item2.hidden\" :index=\"item2.id\">\n                                                <img v-if=\"item2.icon != ''\" :src=\"item2.icon\"/>\n                                                <i v-else class=\"ibiz-menu-icon\" v-if=\"item2.iconcls != ''\" :class=\"item2.iconcls\" aria-hidden=\"true\"></i>\n                                                <span slot=\"title\">{{ item2.text }}</span>\n\n                                                <span class='pull-right' v-if=\"counterdata[item2.counterid] && counterdata[item2.counterid] > 0\">\n                                                    <badge :count=\"counterdata[item2.counterid]\" :overflow-count=\"maxNumber\">\n                                                    </badge>\n                                                </span>\n\n                                            </el-menu-item>\n                                        </template>\n                                        <!---  \u4E09\u7EA7\u83DC\u5355\u6709 begin  --->\n\n                                    </el-submenu>\n                                </template>\n                                <!---  \u4E8C\u7EA7\u83DC\u5355\u6709\u5B50\u9879 end  --->\n\n                                <!---  \u4E8C\u7EA7\u83DC\u5355\u65E0\u5B50\u9879 begin  --->\n                                <template v-else>\n                                    <el-menu-item v-show=\"!item1.hidden\" :index=\"item1.id\">\n                                        <img v-if=\"item1.icon != ''\" :src=\"item1.icon\"/>\n                                        <i v-else class=\"ibiz-menu-icon\" v-if=\"item1.iconcls != ''\" :class=\"item1.iconcls\" aria-hidden=\"true\"></i>\n                                        <span slot=\"title\">{{ item1.text }}</span>\n\n                                        <span class='pull-right' v-if=\"counterdata[item1.counterid] && counterdata[item1.counterid] > 0\">\n                                            <badge :count=\"counterdata[item1.counterid]\" :overflow-count=\"maxNumber\">\n                                            </badge>\n                                        </span>\n\n                                    </el-menu-item>\n                                </template>\n                                <!---  \u4E8C\u7EA7\u83DC\u5355\u65E0\u5B50\u9879 end  --->\n\n                            </template>\n                        </el-submenu>\n                    </template>\n                    <!---  \u4E00\u7EA7\u83DC\u5355\u6709\u5B50\u9879 end  --->\n\n                    <!---  \u4E00\u7EA7\u83DC\u5355\u65E0\u5B50\u9879 begin  --->\n                    <template v-else>\n                        <el-menu-item v-show=\"!item0.hidden\" :index=\"item0.id\">\n                            <img v-if=\"item0.icon != ''\" :src=\"item0.icon\"/>\n                            <i v-else class=\"ibiz-menu-icon\" :class=\"[item0.iconcls == '' ? 'fa fa-cogs' : item0.iconcls ]\" aria-hidden=\"true\"></i>\n                            <span slot=\"title\">{{ item0.text }}</span>\n\n                            <span class='pull-right' v-if=\"counterdata[item0.counterid] && counterdata[item0.counterid] > 0\">\n                                <badge :count=\"counterdata[item0.counterid]\" :overflow-count=\"maxNumber\">\n                                </badge>\n                            </span>\n\n                        </el-menu-item>\n                    </template>\n                    <!---  \u4E00\u7EA7\u83DC\u5355\u65E0\u5B50\u9879 end  --->\n\n                </template>\n            </el-menu>\n        </div>\n    ",
    props: ['ctrl', 'viewController', 'isCollapse', 'mode'],
    data: function () {
        var data = {
            trigger: 'click',
            counterdata: {},
            uiCounterEvent: null,
            maxNumber: IBizEnvironment.AppMenuUICounterMaxNumber ? IBizEnvironment.AppMenuUICounterMaxNumber : 9999,
        };
        return data;
    },
    created: function () {
        if (Object.is(this.mode, 'horizontal')) {
            this.trigger = 'hover';
        }
        this.subscribeUICounter();
    },
    destroyed: function () {
        this.unSubscribeUICounter();
    },
    methods: {
        subscribeUICounter: function () {
            var _this = this;
            if (!this.ctrl.getUICounterName() || Object.is(this.ctrl.getUICounterName(), '')) {
                return;
            }
            var UICounter = this.viewController.uicounters.get(this.ctrl.getUICounterName());
            this.counterdata = {};
            Object.assign(this.counterdata, UICounter.getData());
            this.uiCounterEvent = UICounter.on(IBizUICounter.COUNTERCHANGED).subscribe(function (data) {
                _this.counterdata = {};
                Object.assign(_this.counterdata, data);
            });
        },
        unSubscribeUICounter: function () {
            if (this.uiCounterEvent) {
                this.uiCounterEvent.unsubscribe();
            }
        },
        onSelect: function (name) {
            if (this.ctrl && !Object.is(name, '')) {
                var item = this.ctrl.getItem(this.ctrl.getItems(), { id: name });
                this.ctrl.onSelectChange(item);
            }
        }
    }
});
